#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Random Colors
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Face Tool>Random Colors
#		 Note:	
#			
#    Date:	Jun 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Face_tools.add_item('Random Colors') { Random_Colors.main }
	file_loaded(__FILE__)
end
#
module Random_Colors

	def self.main
		mod = Sketchup.active_model
		ent = mod.entities
		sel = mod.selection
		unless sel.empty?
			@Faces=sel.grep(Sketchup::Face)
			unless @Faces.empty?
				@Color_Source ||= "Sketchup"; @Select_Order ||= "Random"
				val = UI.inputbox(["Color Source:","Select Order:"],[@Color_Source,@Select_Order],["Sketchup|Gradiant|Palette","Random|InOrder"],"Randow Colors")
				if val
					@colors=Sketchup::Color.names; @Color_Source = val[0]; @Select_Order = val[1]
					case @Color_Source
						when "Sketchup"
							val = UI.inputbox(["Number of Colors:"],[@colors.length],"Random Colors")
							if val
								max = val[0].to_i; ndx = 0; srand()
								mod.start_operation "Random Colors"
								max<@colors.length ? @colors.shuffle! : max=@colors.length
								@Faces.each{|f|
									case @Select_Order
										when "Random"
											f.material = @colors[rand(max)]
										when "InOrder"
											f.material = @colors[ndx]; ndx += 1; ndx %= max
									end
								}
								mod.commit_operation
							end
						when "Gradiant"
							if @Select_Order == "InOrder"
								@stack = {}; # Sort faces by distance to Model Origin
								@Faces.each{|face| @stack[face]=ORIGIN.distance(face.bounds.center)}
								@Faces = @stack.sort { |a,b| a[1] <=> b[1] }.map { |n| n[0] }
							else
								@Faces.shuffle!
							end
							self.clrgrd_dialog
						when "Palette"
							@inp_dir ||= "c:/users/public/temp/"; @inp_name ||= "colors.txt"
							inp_file = UI.openpanel("Import Palette From:", @inp_dir, @inp_name)
							if inp_file
								clr_file = File.open(inp_file)
								@inp_name = File.basename(inp_file)
								@colors = []; debug=true
								mod.start_operation "Random Colors"
								while !clr_file.eof?
									argb = clr_file.readline.strip; #puts argb,argb.index(";") if debug; debug=false
									# next if argb.index(";")
									next unless argb[0..1]=='FF' 
									# next if argb=="FF000000" || argb=="FFFFFFFF" #remove comment to exclude black and white
									@colors << "#"+argb[2..7]
								end
								max = @colors.length; ndx = 0; srand()
								@Faces.each{|f|
									case @Select_Order
										when "Random"
											f.material = @colors[rand(max)]
										when "InOrder"
											f.material = @colors[ndx]; ndx += 1; ndx %= max
									end
								}
								mod.commit_operation
							end
					end
				end
			else
				UI.messagebox "No faces found in the selection"
			end
		else
			UI.messagebox "Nothing selected"
		end
	end
	
	def self.clrgrd_dialog
	
		mod = Sketchup.active_model
		ent = mod.entities
		sel = mod.selection
		
		@ClrGrd = UI::WebDialog.new("ColorGradiant", false, "CGID", 10, 10, 200, 100, true)
		
		@clr_list1 = ""; @clr_list2 = ""
		@Start_Clr ||= "Red"; @End_Clr ||= "Blue"
		@colors.each{ |e| 
			@TmpClr = Sketchup::Color.new e
			@clr_list1 += "<option value='"+e+"' #{e==@Start_Clr ? 'selected' : ''} "+ \
			"style=background-color:rgb("+@TmpClr.red.to_s+","+@TmpClr.green.to_s+","+@TmpClr.blue.to_s+")>"+e+"</option>" 
			@clr_list2 += "<option value='"+e+"' #{e==@End_Clr ? 'selected' : ''} "+ \
			"style=background-color:rgb("+@TmpClr.red.to_s+","+@TmpClr.green.to_s+","+@TmpClr.blue.to_s+")>"+e+"</option>" 
		}
		
		clr_grd_html =
			'<!DOCTYPE html>
			<html lang="en-US">
				<head>
					<meta charset="utf-8" />
					<meta content="IE=edge" http-equiv="X-UA-Compatible" />
				</head>
				<body style="background-color:powderblue">
					<script type="text/javascript">
						function callBegin() {query = "skp:get_action@" + "begin";
						window.location.href = query;}
						function callClose() {query = "skp:get_action@" + "close";
						window.location.href = query;}
					</script>
					<center>
						<br>Start Color:<select id="clr1_name">'+@clr_list1+'</select>
						<br><br>End Color:<select id="clr2_name">'+@clr_list2+'</select>
						<br><br><input type="button" onclick="callBegin()" value=" OK ">  
						<input type="button" onclick="callClose()" value=" Cancel "><br>
					</center>
				</body>
			</html>'
			
		@ClrGrd.add_action_callback("get_action") do |web_dialog,action_name|
			case action_name
				when "begin"
					mod.start_operation "Random Colors"
					clr1 = Sketchup::Color.new @ClrGrd.get_element_value("clr1_name")
					clr2 = Sketchup::Color.new @ClrGrd.get_element_value("clr2_name")
					inc = 1.0/(@Faces.length-1).to_f; clrs=[]
					0.step(1.0,inc) {|x| clrs<<clr2.blend(clr1,x) }
					@Faces.each_with_index{|f,i| f.material=clrs[i]}
					mod.commit_operation
					@ClrGrd.close
				when "close"
					@ClrGrd.close
			end
			
		end
		
		@ClrGrd.set_html(clr_grd_html)
		RUBY_PLATFORM =~ /(darwin)/ ? @ClrGrd.show_modal() : @ClrGrd.show();
		
	end
	
end
